	; Tiny program by Eric Auer, derived from some
	; know-how found in the kernel sources of Linux.
	; Will modify VGA 80x25 text mode into 80x30 text
	; mode :-). Not TSR. License: Public Domain.

	org 0x100

start:	mov dx,0x3d4
	mov si,table
	mov cx,7
	cld

crtloop:
	lodsw
	out dx,ax
	jmp short dly1
dly1:	loop crtloop

	xor ax,ax
	xor ax,ax

	mov dx,0x3cc; set some special flags
	in al,dx
	and al,0xd
	or al,0xe2
	mov dx,0x3c2
	out dx,al
	jmp short biset; jump to BIOS stuff

	db "VGA25->VGA30 changer, derived"
	db " from Linux-Kernel-Source"

table	dw 0x0c11, 0x0b06, 0x3e07, 0xea10
	dw 0xdf12, 0xe715, 0x0416

	db "ENDE (EA) "

biset: 	push ds		; finally, adjust BIOS data
	mov ax,0x40	; BIOS data seg
	mov ds,ax
	mov word [0x4c],0x12c0
	mov byte [0x84],0x1d	; max row = 29
	pop ds
	int 0x20; leave

	db "BIOS!VGA ass"

